#!/bin/bash

THIS_DIR=$(cd $(dirname $0); pwd)


echo "**********************************************"
echo " Running VCenter Database Scripts $(date) "
echo "**********************************************"

if [ ! -f /etc/sysconfig/spectre-lame ]; then

 echo "Copying Trust File into ${postgresql_data}/"
 cp $THIS_DIR/pg_hba.conf.trust ${postgresql_data}/pg_hba.conf
 cp $THIS_DIR/postgresql.conf ${postgresql_data}

 echo "Restarting the Database"
 systemctl restart ${postgresql}
  
 array=($THIS_DIR/DBScripts/DBVCenter/01CreateDB/* $THIS_DIR/DBScripts/DBVCenter/02CreateTables/* $THIS_DIR/DBScripts/DBVCenter/03PopulateData/* $THIS_DIR/DBScripts/DBVCenter/04CreateViews/* $THIS_DIR/DBScript/DBVCenter/05CreateFunctions/* $THIS_DIR/DBScripts/DBVCenter/1.0.1Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/1.0.1Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/1.0.1.1Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/1.0.1.1Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/1.0.2Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/1.0.2Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/1.5.1Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/1.5.1Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/1.5.2Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/1.6.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/1.7.0Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/1.7.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/2.0.0Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/2.0.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/2.1.0Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/2.1.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/2.2.0Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/2.2.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/3.0.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/3.1.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/4.0.0Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/4.0.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/4.0.1Upgrade/*SchemaChanges.sql  $THIS_DIR/DBScripts/DBVCenter/4.0.1Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/4.1.0Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/4.1.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/4.2.0Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/4.2.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/4.3.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/5.0.0Upgrade/*DataRemoval.sql $THIS_DIR/DBScripts/DBVCenter/5.0.0Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/5.0.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/5.1.0Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/5.1.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/5.2.0Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/5.2.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/5.3.0Upgrade/*SchemaChanges.sql $THIS_DIR/DBScripts/DBVCenter/5.3.0Upgrade/*DataChanges.sql $THIS_DIR/DBScripts/DBVCenter/5.4.0Upgrade/*DataChanges.sql)
 
# exec &>$THIS_DIR/dbScript_log.log

len=${#array[*]}

# echo "The Number of script files are: $len"

echo  "                                     "

# Role, Database and plpgsql are static. therefore we execute outsite the loop.
echo  "Creating role..."
${postgresql_bin}/psql -h localhost -U postgres -d postgres -f "$THIS_DIR/DBScripts/DBVCenter/01CreateDB/01RoleCreation.sql"
echo  "Creating VCenterDB..."
${postgresql_bin}/psql -h localhost -U postgres -d postgres -f "$THIS_DIR/DBScripts/DBVCenter/01CreateDB/02DBCreation.sql"
echo  "Adding plpgsql to VCenterDB..."
${postgresql_bin}/createlang plpgsql -U postgres -d VCenterDB

i=0

      while [ $i -lt $len ]; do
	
         
        echo "${array[$i]}"

        if  [ ${array[$i]:${#array[$i]}-3:3} = "txt" ] ; then
                echo "Skip this one"
        else if [ ${array[$i]:${#array[$i]}-3:3} = "sql" ] ; then
                ${postgresql_bin}/psql -h localhost -U postgres -d VCenterDB -f "${array[$i]}"
		else
               echo Not Executable    
            fi
       fi  
       let i++
   done

fi
# end if not exist /etc/sysconfig/spectre-lame

  echo "**********************************************"
 echo "Copying Production File into ${postgresql_data}/"
 cp $THIS_DIR/pg_hba.conf.prd ${postgresql_data}/pg_hba.conf

 echo "**********************************************"
 echo "Copying postgresql.conf into ${postgresql_data}/"
 cp $THIS_DIR/postgresql.conf ${postgresql_data}/postgresql.conf
 
echo "Restarting the Database"
systemctl restart ${postgresql}

sleep 15

# service tomcatSpectre restart

echo  "**********************************************"
echo   " VCenter Database Scripts Ended $(date)"
